org.apache.lucene.spatial3d.geom

## Interface GeoPath

- All Superinterfaces:
    Bounded, GeoArea, GeoAreaShape, GeoDistance, GeoDistanceShape, GeoMembershipShape, GeoOutsideDistance, GeoShape, Membership, PlanetObject, SerializableObject

      public interface GeoPath
      extends GeoDistanceShape

  Interface describing a path.
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Field Summary

    - ### Fields inherited from interface org.apache.lucene.spatial3d.geom.GeoArea

      `CONTAINS, DISJOINT, OVERLAPS, WITHIN`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `double` | `computeNearestDistance(DistanceStyle distanceStyle, double x, double y, double z)` Compute the nearest path distance to the GeoPoint.
    `default double` | `computeNearestDistance(DistanceStyle distanceStyle, GeoPoint point)` Compute the nearest path distance to the GeoPoint.
    `double` | `computePathCenterDistance(DistanceStyle distanceStyle, double x, double y, double z)` Compute the shortest distance from the path center to the GeoPoint.
    `default double` | `computePathCenterDistance(DistanceStyle distanceStyle, GeoPoint point)` Compute the shortest distance from the path center to the GeoPoint.

    - ### Methods inherited from interface org.apache.lucene.spatial3d.geom.GeoDistanceShape

      `getDistanceBounds`

    - ### Methods inherited from interface org.apache.lucene.spatial3d.geom.GeoAreaShape

      `intersects`

    - ### Methods inherited from interface org.apache.lucene.spatial3d.geom.GeoShape

      `getEdgePoints, intersects`

    - ### Methods inherited from interface org.apache.lucene.spatial3d.geom.Bounded

      `getBounds`

    - ### Methods inherited from interface org.apache.lucene.spatial3d.geom.PlanetObject

      `getPlanetModel`

    - ### Methods inherited from interface org.apache.lucene.spatial3d.geom.SerializableObject

      `readBitSet, readBoolean, readByteArray, readClass, readDouble, readHeterogeneousArray, readHomogeneousArray, readInt, readLong, readObject, readObject, readObject, readObject, readPlanetObject, readPointArray, readPolygonArray, readString, write, writeBitSet, writeBoolean, writeByteArray, writeClass, writeDouble, writeHeterogeneousArray, writeHeterogeneousArray, writeHomogeneousArray, writeHomogeneousArray, writeInt, writeLong, writeObject, writePlanetObject, writePointArray, writePointArray, writePolygonArray, writePolygonArray, writeString`

    - ### Methods inherited from interface org.apache.lucene.spatial3d.geom.GeoOutsideDistance

      `computeOutsideDistance, computeOutsideDistance`

    - ### Methods inherited from interface org.apache.lucene.spatial3d.geom.Membership

      `isWithin, isWithin`

    - ### Methods inherited from interface org.apache.lucene.spatial3d.geom.GeoArea

      `getRelationship`

    - ### Methods inherited from interface org.apache.lucene.spatial3d.geom.GeoDistance

      `computeDeltaDistance, computeDeltaDistance, computeDistance, computeDistance`

- - ### Method Detail

    - #### computeNearestDistance

          default double computeNearestDistance(DistanceStyle distanceStyle,
                                                GeoPoint point)

      Compute the nearest path distance to the GeoPoint. The path distance will not include the distance from the path itself to the point, but just the distance along the path to the nearest point on the path.
      Parameters:
        `distanceStyle` - is the distance style.
        `point` - is the point to compute the distance to.
      Returns:
        the distance to the nearest path point.

    - #### computeNearestDistance

          double computeNearestDistance(DistanceStyle distanceStyle,
                                        double x,
                                        double y,
                                        double z)

      Compute the nearest path distance to the GeoPoint. The path distance will not include the distance from the path itself to the point, but just the distance along the path to the nearest point on the path.
      Parameters:
        `x` - is the point's unit x coordinate (using U.S. convention).
        `y` - is the point's unit y coordinate (using U.S. convention).
        `z` - is the point's unit z coordinate (using U.S. convention).
      Returns:
        the distance to the nearest path point.

    - #### computePathCenterDistance

          default double computePathCenterDistance(DistanceStyle distanceStyle,
                                                   GeoPoint point)

      Compute the shortest distance from the path center to the GeoPoint. The distance is meant to allow comparisons between different paths to find the one that goes closest to a point.
      Parameters:
        `distanceStyle` - is the distance style.
        `point` - is the point to compute the distance to.
      Returns:
        the shortest distance from the path center to the point.

    - #### computePathCenterDistance

          double computePathCenterDistance(DistanceStyle distanceStyle,
                                           double x,
                                           double y,
                                           double z)

      Compute the shortest distance from the path center to the GeoPoint. The distance is meant to allow comparisons between different paths to find the one that goes closest to a point.
      Parameters:
        `distanceStyle` - is the distance style.
        `x` - is the point's unit x coordinate (using U.S. convention).
        `y` - is the point's unit y coordinate (using U.S. convention).
        `z` - is the point's unit z coordinate (using U.S. convention).
      Returns:
        the shortest distance from the path center to the point.

Copyright © 2000-2020 Apache Software Foundation. All Rights Reserved.